<template>
	<!-- 轮播图配置 -->
	<xn-form-container :title="'基本设置'" :width="800" :visible="visible" :destroy-on-close="true" @close="onClose">
		<a-form :model="formState" ref="formStateRef" :rules="formStateRules" name="basic" autocomplete="off">
			<div class="form">
				<a-row>
					<a-col :span="12">
						<a-form-item class="form-item" label="跳转链接" name="redirectUrl" :label-col="{ span: 10 }">
							<a-input
								placeholder="请输入跳转链接"
								style="width: 600px"
								:disabled="disabled"
								v-model:value="formState.redirectUrl"
							/>
						</a-form-item>
					</a-col>
				</a-row>
				<!--  -->
			</div>

			<div class="attachment">
				<a-form-item ref="uploadDataList" class="form-item" label="新闻图片" name="attachment" :label-col="{ span: 3 }">
					<DIYUPLoad
						:beforeUpload="beforeUpload"
						multiple
						:disabled="disabled"
						:change="changeUpload"
						listType="picture-card"
						v-model:urls="formState.carouselImage"
					></DIYUPLoad>
					<div style="color: #8c8c8c">(建议尺寸:1160px*92px)</div>
				</a-form-item>
			</div>

			<a-form-item>
				<div class="item-submit">
					<a-button class="btn1" :disabled="disabled" @click="onFinish(2)">提交</a-button>
					<a-button class="btn1" :disabled="disabled" type="primary" @click="onFinish(1)">保存</a-button>
				</div>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
		</template>
	</xn-form-container>
</template>
<script lang="js">
	import business from '@/api/home/home.js'
	import { ref } from 'vue'
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import global from '@/api/home/global.js'
	export default {
		name: 'FromName',
		components: {},
		emits: ['change'],
		setup(props, { emit }) {
			const disabled = ref(false)
			const visible = ref(false)
			const records = ref('')
			const onOpen = (record, flag, view, row) => {
				records.value = record
				visible.value = flag
				disabled.value = view
				if (row) {
					detail(row.id)
				}
			}
			const rest = () => {
				for (let key in formState.value) {
					formState.value[key] = ''
				}
			}
			const detail = async (v) => {
				const res = await business.LUNBOTUdetail({ id: v })
				formState.value = res
				formState.value.carouselImage = (res.carouselImage || '').split(',').filter((v) => v)
			}
			const onClose = () => {
				visible.value = false
				rest()
			}
			watch(
				() => visible.value,
				(newVal) => {
					if (!newVal) {
						setTimeout(() => {
							rest()
						}, 0)
					}
				},
				{ immediate: true, deep: true }
			)

			const formState = ref({
				redirectUrl: '',
				carouselImage: '',
				status: 0
			})
			const formStateRules = ref({
				// systemName: [{ required: true, message: '请填写!', trigger: 'blur' }],
				// publishTime: [{ required: true, message: '请填写!', trigger: 'change' }],
				// attachment: [{ required: true, message: '请填写!', trigger: 'change' }]
			})
			const formStateRef = ref(null)
			const onFinish = async (status) => {
				formStateRef.value.validate().then(async () => {
					try {
						if (Array.isArray(formState.value.carouselImage)) {
							formState.value.carouselImage = formState.value.carouselImage.join(',')
						}
						formState.value.status = status
						await handleAdd(formState.value)
						emit('change')
						onClose()
					} catch (err) {
						console.log(err)
					}
				})
			}

			const handleAdd = async (val) => {
				if (records.value == 'edit') {
					const res = await business.LUNBOTUedit(val)
				} else {
					const res = await business.LUNBOTUadd(val)
					console.log('add')
				}
			}

			const delADD = () => {
				formStateRef.value.validate().then(() => {})
			}

			const onFinishFailed = (errorInfo) => {
				console.log('Failed:', errorInfo)
			}
			function changeUpload(fd) {
				return global.uploadFile(fd).then((reg) => {
					uploadDataList.value.clearValidate()
					return reg
				})
			}
			const uploadDataList = ref(null)
			function beforeUpload() {
				uploadDataList.value.clearValidate()
			}

			return {
				beforeUpload,
				uploadDataList,
				changeUpload,
				delADD,
				formStateRef,
				formStateRules,
				formState,
				onFinish,
				onFinishFailed,
				disabled,
				onOpen,
				visible,
				onClose
			}
		}
	}
</script>
<style lang="less" scoped>
	.box1 {
		display: flex;
		justify-content: space-between;
		.box-left {
			width: 350px;
			align-items: center;
		}
		.box-right {
			width: 350px;
			margin-right: 10px;
			align-items: center;
		}
	}
	.common {
		display: flex;
		align-items: center;
		justify-content: center;
		margin-bottom: 30px;
		.title {
			width: 130px;
			text-align: right;
			margin-right: 5px;
		}
	}
	.input {
		margin-right: 10px;
		margin-left: 40px;
		margin-top: 20px;
		.ant-input-affix-wrapper {
			height: 100px;
		}
	}
	.btnBox {
		text-align: center;
		margin-top: 100px;
		.snowy-buttom-left {
			margin-left: 100px;
		}
		.acc {
			width: 80px;
			height: 40px;
		}
	}
	.form {
		display: flex;
		flex-wrap: wrap;
		// justify-content: center;
		.form-item {
			width: 250px;
			margin-right: 120px;
		}
	}
	.item-submit {
		display: flex;
		justify-content: center;
		margin-top: 100px;
		.btn1 {
			width: 100px;
			margin-right: 20px;
		}
	}
	.ant-select {
		width: 250px;
	}
	.ant-input {
		width: 250px;
	}
	.ant-form-item-label {
		width: 150px;
	}
	.attachment {
		margin-top: 30px;
		margin-left: 15px;
	}
</style>
